#include <SpeechRecognition.h>
#include <AppleEvents.h>

pascal OSErr MyHandleSpeechDetected (AppleEvent *theAEevt, AppleEvent *reply, long refcon);


pascal OSErr MyHandleSpeechDetected (AppleEvent *theAEevt, AppleEvent *reply, 
																	long refcon)
{
	OSErr 					myErr = noErr;
	long 					actualSize;
	DescType 				actualType;
	OSErr 					recStatus = noErr;
	SRRecognizer 			myRec;

	/* Get the status and recognizer. 						*/
	myErr = AEGetParamPtr (theAEevt, keySRSpeechStatus, typeShortInteger,
				&actualType, (Ptr) &recStatus, sizeof (recStatus), &actualSize);
	if (!myErr) myErr = recStatus;
	if (!myErr) {
		myErr = AEGetParamPtr (theAEevt, keySRRecognizer, typeSRRecognizer, 
						&actualType, (Ptr) &myRec, sizeof (myRec), &actualSize);
		
		if (!myErr) {
			/* The user has started speaking. We can adjust the language model	*/
			/* to reflect the current context. Then we must call either 		*/
			/* SRContinueRecognition or SRCancelRecognition.					*/ 
			
			myErr = SRContinueRecognition (myRec);
		}
	}

	return myErr;
}