#include <SpeechRecognition.h>

pascal void		MyNotificationCallBack (SRCallBackStruct *param);

SRRecognitionResult	gLastRecResult;

pascal void MyNotificationCallBack (SRCallBackStruct * param)
{
	OSErr		myErr = param->status;
	
	if (!myErr) {
		/* Handle recognition beginning event - the user just started speaking */
		/* Here we just continue speech recognition */
		if ((param->what) & kSRNotifyRecognitionBeginning) {
			SRRecognizer	rec = (SRRecognizer) (param->instance);
			
			myErr = SRContinueRecognition (rec);
		}
		
		/* Handle recognition done event									*/
		/* Here we save the rec result in gLastRecResult. 					*/
		/* At idle time in our event loop, if gLastRecResult != NULL,		*/
		/* we call MyProcessRecognitionResult (gLastRecResult)				*/
		else if (param->what & kSRNotifyRecognitionDone) {
			SRRecognitionResult recResult = 
										(SRRecognitionResult) (param->message);
			if (recResult)
				gLastRecResult = recResult;
				/* Note that we might get more than one result before we 	*/
				/* get to our idle check, so we should really be putting	*/
				/* this in a queue. 										*/
		}
	}
}
