#include <SpeechRecognition.h>
#include <stdio.h>

void MyProcessRecognitionResult (SRRecognitionResult recResult);

extern OSErr MyCallPersonInPath (SRPath recognizedPath);

#define			kTopLMRefCon 		'top '
#define			kCallPersonRefCon	'call'
#define			kRejectedWordRefCon	'rejc'

void MyProcessRecognitionResult (SRRecognitionResult recResult)
{
	OSErr				myErr = noErr;

	if (recResult) {
		SRLanguageModel	myResultLM;
		Size			myLen;
		
		myLen = sizeof (myResultLM);
		myErr = SRGetProperty (recResult, kSRLanguageModelFormat, &myResultLM, &myLen);
		
		if (!myErr)	{
			long 				myRefCon;
			SRLanguageObject	mySubElement;
			
			myLen = sizeof (myRefCon);
			myErr = SRGetProperty (myResultLM, kSRRefCon, &myRefCon, &myLen);
			
			if (!myErr) {
				switch (myRefCon) {
					case kRejectedWordRefCon:
						/* Here we do nothing if the utterace was rejected */
						break;
					
					case kTopLMRefCon:
						/*	if it's a valid result from our top-level LM, 	*/
						/*	then parse and process its elements 			*/
						
						/* TopLM one sub-element, one of the following:		*/
						/* "<call><person>" (SRPath with kCallPersonRefCon),*/
						/* "schedule meeting with <person>" (SRPath), or	*/
						/* "view today's schedule" (SRPhrase) 				*/
						
						/* we get the sub-element							*/
						myErr = SRGetIndexedItem (myResultLM, &mySubElement, 0);
						if (!myErr) {
							myLen = sizeof (myRefCon);
							myErr = SRGetProperty (mySubElement, kSRRefCon, &myRefCon, &myLen);
							
							/* Call a subroutine to process the subelement	*/
							if (!myErr) switch (myRefCon)
								{
								case kCallPersonRefCon:
									myErr = MyCallPersonInPath 
														((SRPath) mySubElement);
									break;
								
								/* ...process "schedule meeting with <person>"*/
								
								/* ...process "view today's schedule" 		*/
								
								default:
									break;
								}
							
							/* release subelement when done with it 		*/
							myErr = SRReleaseObject (mySubElement);
						}
						break;
					
					default:
						break;
				}
			}
			
			/*	release myResultLM fetched above when done with it 			*/
			myErr = SRReleaseObject (myResultLM);
		}
		
		/* Release SRRecognitionResult since we are done with it 			*/
		myErr = SRReleaseObject (recResult);
	}
	
}

